﻿Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Dim dataSet As DataSet
    Dim dataTable As DataTable

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CreateDataSet()
        UltraGrid1.DataSource = dataSet
    End Sub

    Private Sub CreateDataSet()
        dataSet = New DataSet()
        dataTable = New DataTable("Customers")

        dataTable.Columns.Add("CustomerID", GetType(String))
        Dim Keys As DataColumn() = New DataColumn(0) {}
        Keys(0) = dataTable.Columns(0)
        dataTable.PrimaryKey = Keys
        dataTable.Columns.Add("CompanyName", GetType(String))
        dataTable.Columns.Add("ContactName", GetType(String))
        dataTable.Columns.Add("Address", GetType(String))
        dataTable.Columns.Add("City", GetType(String))
        dataTable.Columns.Add("Country", GetType(String))

        Dim row As DataRow = dataTable.NewRow()
        row("CustomerID") = "ALFKI"
        row("CompanyName") = "Alfred Futterkiste"
        row("ContactName") = "Ana Anders"
        row("Address") = "Obere Str. 57"
        row("City") = "Berlin"
        row("Country") = "Germany"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "ANATR"
        row("CompanyName") = "Ana Trujillo Emparedados y helados"
        row("ContactName") = "Ana Trujillo"
        row("Address") = "Avda. de la Constitución 2222"
        row("City") = "México D.F."
        row("Country") = "Mexico"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "ANTON"
        row("CompanyName") = "Antonio Moreno Taquería"
        row("ContactName") = "Antonio Moreno"
        row("Address") = "Mataderos  2312"
        row("City") = "México D.F."
        row("Country") = "Mexico"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "AROUT"
        row("CompanyName") = "Around the Horn"
        row("ContactName") = "Thomas Hardy"
        row("Address") = "120 Hanover Sq."
        row("City") = "London"
        row("Country") = "UK"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BERGS"
        row("CompanyName") = "Berglun snabbköp"
        row("ContactName") = "Christina Berglund"
        row("Address") = "Berguvsvägen  8"
        row("City") = "Luleå"
        row("Country") = "Sweden"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BLAUS"
        row("CompanyName") = "Blauer See Delikatessen"
        row("ContactName") = "Hanna Moos"
        row("Address") = "Forsterstr. 57"
        row("City") = "Mannheim"
        row("Country") = "Germany"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BLONP"
        row("CompanyName") = "Blondel père et fils"
        row("ContactName") = "Frédérique Citeaux"
        row("Address") = "24, place Kléber"
        row("City") = "Strasbourg"
        row("Country") = "France"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BOLID"
        row("CompanyName") = "Bólido Comidas preparadas"
        row("ContactName") = "Martín Sommer"
        row("Address") = "C/ Araquil, 67"
        row("City") = "Madrid"
        row("Country") = "Spain"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BONAP"
        row("CompanyName") = "Bon app'"
        row("ContactName") = "Laurence Lebihan"
        row("Address") = "12, rue des Bouchers"
        row("City") = "Marseille"
        row("Country") = "France"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BOTTM"
        row("CompanyName") = "Bottom-Dollar Markets"
        row("ContactName") = "Elizabeth Lincoln"
        row("Address") = "23 Tsawassen Blvd."
        row("City") = "Tsawassen"
        row("Country") = "Canada"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "BSBEV"
        row("CompanyName") = "B's Beverages"
        row("ContactName") = "Elizabeth Ashworth"
        row("Address") = "Fauntleroy Circus"
        row("City") = "London"
        row("Country") = "UK"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "CACTU"
        row("CompanyName") = "Cactus Comidas para llevar"
        row("ContactName") = "Patricio Simpson"
        row("Address") = "Cerrito 333"
        row("City") = "Buenos Aires"
        row("Country") = "Argentina"
        dataTable.Rows.Add(row)

        row = dataTable.NewRow()
        row("CustomerID") = "CENTC"
        row("CompanyName") = "Centro Comercial de Moctezuma"
        row("ContactName") = "Francisco Chang"
        row("Address") = "Sierras de Granada 9993"
        row("City") = "México D.F."
        row("Country") = "Mexico"
        dataTable.Rows.Add(row)

        dataSet.Tables.Add(dataTable)
    End Sub

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        e.Layout.Override.CellClickAction = CellClickAction.RowSelect
        e.Layout.Override.SelectTypeRow = SelectType.Single
    End Sub

    Private Sub UltraGrid1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles UltraGrid1.MouseDown
        'get the cell that was clicked..
        Dim objCell As UltraGridCell = _
            Me.UltraGrid1.DisplayLayout.UIElement.LastElementEntered.GetContext(GetType(UltraGridCell))

        If Not objCell Is Nothing Then
            'remove the previous selection if there was one...
            'If Me.UltraGrid1.Selected.Rows.Count > 0 Then Me.UltraGrid1.Selected.Rows(0).Selected = False

            objCell.Row.Selected = True
            objCell.Activate()
            MsgBox(Me.UltraGrid1.Selected.Rows.Count)
        End If
    End Sub
End Class
